#include "xbasic_types.h"
#include "xio.h"
//#include "stdlib.h"
#include "xintc_l.h"
#include "xuartlite_l.h"
#include "lut.h"
#define W 640
#define H 480
#define VGA_START 0x00800000
#define AUDIO_START 0xFEFE0000
#define RED 0xE0
#define GREEN 0x1C
#define BLUE 0x03



/*
Font taken from Linux Source 2.4 
/drivers/video/font_8x8.c
 */
#include "font.h"



// defined in isr.c
extern void audio_handler(void *callback);
extern int number_of_frames;
//extern int uart_interrupt_count;
//extern char uart_character;
int out;
//extern char buffer[256];
char stri[33];
extern int in;
void outchar(char c, int row, int col);

void drawline(int sndSrc, int rightMic, int color);
void getinput(char *buffer,int row, int col, char *prompt);
void drawgrid();
void drawBar(int sndSrc, int rightMic, int color);


int flip =0;
int i,j,z;
int xxx;
int screen_start=0;
int cursor=0; //cursor location
int AT,RT,thresh,xdR,xdL,xd2R,xd2L,aR,aL,test1,xdtestR,xdtestL; //meow
int thresh1=50;
int stampR, stampL, freezeR,freezeL,Rst;
int sample_delay,time_delay,old_delay,right;
int count;
int old_frame=0;
int prev_frame=0;


AT=300;//.367;  //tat=.1ms
RT=2;//.0023;  //trt=20ms
thresh=800;//value from testing

char buf[100];
int inputdone=0;


void getinput(char *buffer,int row, int col, char *prompt);

int bpos=0;
int firsttime=0;
char character;




void outstring(char * s,int row, int col);

/*
 * setup_interrupts: Initialize the interrupt sources and handlers
 *
 * Should be called once when the system starts
 *
 * The main _interrupt_handler() function from Xilinx
 *
 * Saves and restores CPU context, etc.
 *
 * Sees which interrupts are pending, and for each it
 *     acknowledges the interrupt and
 *     calls a user-defined interrupt handler in Xintc_InterruptVectorTable
 *
 * Place interrupt service routines in isr.c to ensure they are placed in
 * the proper memory segment.
 */

void setup_interrupts()
{
  /*
   * Reset the interrupt controller peripheral
   */

  /* Disable the interrupt signal */
  XIntc_mMasterDisable(XPAR_INTC_SINGLE_BASEADDR);

  /* Disable all interrupt sources */
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR,0);

  /* Acknowledge all possible interrupt sources
     to make sure none are pending */
  XIntc_mAckIntr(XPAR_INTC_SINGLE_BASEADDR, 0xffffffff);

  /*
   * Install the UART interrupt handler
   */

  XIntc_InterruptVectorTable[XPAR_INTC_AK4565_INTERRUPT_INTR].Handler =
    audio_handler;

  /*
   * Enable interrupt sources
   */

  /* Enable CPU interrupts */
  microblaze_enable_interrupts();

  /* Enable interrupts from the interrupt controller */
  XIntc_mMasterEnable(XPAR_INTC_SINGLE_BASEADDR);

  /* Tell the interrupt controller to accept interrupts from the UART */
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR, XPAR_AK4565_INTERRUPT_MASK);
  
  /* Enable UART interrupt generation */
  XUartLite_mEnableIntr(XPAR_AK4565_BASEADDR);
}

Xuint32 pixl[64], pixr[64];

int main()
{
  int i,c,k,l,x,y; //various temporary variables
  int row=0,col=0;
 
  // Enable the instruction cache: makes the code run 6 times faster
  int stall;

  Xint32 w;
  Xint16 al,ar;
  Xint32 maxnum=0;
  Xint16 alA,arA;  

  microblaze_enable_icache();

  setup_interrupts();


  ///////////////////////erasing screen/////////////////////////
  for(x=0; x < H*W; x++)
    {
      XIo_Out8(VGA_START + x,0);
    }
  //////////////////////////////////////////////////////////////

  drawgrid();

  do {
    ////////////////////////tic toc/////////////////////////////    
 if (number_of_frames-old_frame>=763)
      {
	old_frame=number_of_frames;
	flip=flip+1;
	
	if (flip%2==0)
	  {
	    outchar('Tic',75,59);
	  }
	if (flip%2==1)
	  {
	    outchar('o',76,59);
	  }
      }
 /////////////////////////////////////////////////////////     

 for(i=0; i<64; i++)  //64 samples per frame
       {     

	 if (Rst==1)//reset
	   {
	     freezeR=0;
	     freezeL=0;
	     Rst=0;
	   }

	 XIo_Out32(AUDIO_START+(i<<2), 0);
	 w = XIo_In32(AUDIO_START);

         al = w & 0xFFFF;
	 ar =(w>>16) & 0xFFFF;
       
	 //absolute value
	 alA=abs(al);
	 arA=abs(ar);

	 //dropping lower bits
	 alA>>=4;
	 arA>>=4;

	 //noise floor
	 if(abs(al)>thresh1 && freezeL!=1){
	   //display block (reference)
	   
	   //	 pixl[i] = VGA_START + i + W*(al+H/2);
	   //XIo_Out8(pixl[i], RED); 
	   
  
	   //BEGIN PEAK DETECTORs
	  
	   //left
	   aL=abs(alA)-xd2L;
	   if (aL<0)
	     {aL=0;}
	   xdL=xd2L*(1000-RT)/1000+(AT*aL)/1000;
	   xdtestL=xdL*1000;
	   //thresh is our peak threshold based on diff. equation
	   if (xdtestL>thresh)
	     {
	       stampL=number_of_frames*64 + i;
	       freezeL = 1;
	       right=0;
	       outchar('H',30,30);
	       outchar(' ',31,30);
	       outchar(' ',32,30);
	       
	     }
	   else//if signal is above noise floor, but not peaked
	     {
	       outchar(' ',30,30);
	       outchar('h',31,30);
	       outchar(' ',32,30);
	     }
	 }
	 //if signal is below noise floor:
	 else{
	   outchar(' ',30,30);
	   outchar(' ',31,30);
	   outchar('B',32,30);
	   xdR=0;
	 }       
	 //becomes xd(n-1) next time around
	 xd2L=xdL;
	 //end left peak detection 


       //right,starting with its own noise floor     
       //XIo_Out8(pixr[i], 0);
       if(abs(ar)>thresh1 && freezeR!=1){
	
	 // pixr[i] = VGA_START + i + 64 + W*(ar+H/2);
	 //XIo_Out8(pixr[i], GREEN);     

	 aR=abs(arA)-xd2R;
	 if (aR<0)
	   {aR=0;}
      	 xdR=xd2R*(1000-RT)/1000+(AT*aR)/1000;
	 xdtestR=xdR*1000;
	 //thresh is our peak threshold based on diff. equation
	 if (xdtestR>thresh)
	   {
	     stampR=number_of_frames*64 + i;
	     freezeR=1;
	     right=1;
	     outchar('H',30,31);
	     outchar(' ',31,31);
	     outchar(' ',32,31);
	   }
	 else
	 {
	   outchar(' ',30,31);
	   outchar('h',31,31);
	   outchar(' ',32,31);
	 }
       }
       //if signal is below noise floor:
       else{
	 outchar(' ',30,31);
	 outchar(' ',31,31);
	 outchar('B',32,31);
	 xdR=0;
       }       
       //becomes xd(n-1) next time around
       xd2R=xdR;
       
       //draw the line
       if (freezeL==1 && freezeR==1){
	 drawBar(lut[old_delay], right,0); //erase
	 sample_delay=abs(stampR-stampL);
	 time_delay=sample_delay *20.5;//us
	 //	 print("\n\rDelay: ");
	 if (time_delay/6>=1000){
	   outchar('E',35,31);
	 }
	 else{outchar(' ',35,31);}
	 //	 putnum(time_delay/6);
	 	 Rst=1;	 
		 //////////////////end draw line


	 if (old_delay<1000)drawBar(lut[old_delay], right, 200);
       }

       /*
       for(time_delay = 0;time_delay <6000;time_delay+=300)
	 {
	   drawBar(lut[old_delay],1,100);
	   for(stall=0;stall<1000000;stall++){}
	   old_delay=time_delay/6;
	   drawBar(lut[old_delay],1,200);	   
	 }
       */

     }//ends for i<64
  } while(1);//end do

  return 0;
}//end main



void outstring(char * s,int row, int col)
{
  int f=0;
  while (s[f]!=0) {
    outchar(s[f],row,col+f);
    f++;
  };
  
}

void drawBar(int sndSrc, int rightMic, int color)
{
  //width varies from 6 (pixel 0-63), to 2 (at pixel 319)
  int width = -(sndSrc/64)+6;
  int barCtr;

 switch(width)
   {
   case 6:
     for(barCtr = 0;barCtr<width+1;barCtr++)
       {
     drawline(sndSrc-3+barCtr, rightMic, color);
       }
     break;
   case 5:
     for(barCtr = 0;barCtr<width;barCtr++)
       {
     drawline(sndSrc-2+barCtr, rightMic, color);
       }
     break;
   case 4:
     for(barCtr = 0;barCtr<width+1;barCtr++)
       {
     drawline(sndSrc-2+barCtr, rightMic, color);
       }
     break;
   case 3:
     for(barCtr = 0;barCtr<width;barCtr++)
       {
     drawline(sndSrc-1+barCtr, rightMic, color);
       }
     break;
   case 2:
     for(barCtr = 0;barCtr<width;barCtr++)
       {
     drawline(sndSrc-rightMic+barCtr, rightMic, color);
       }
     break;      
   }
}

void drawline(int sndSrc, int rightMic, int color)
{
  int height;
  int barHeight = 64;
  if (rightMic==0)
    {
      rightMic=-1;
    }

  for(height=0;height<barHeight;height++)
    {
      XIo_Out8(VGA_START + (W*(42+height))+(rightMic*sndSrc)+320,color);
    }
}

void drawgrid()
{
  int across,down,axis;

  //top grid
  //draw grid lines for 0,64,...596
  for(across = 0;across<640;across += 64)
{
    for(down = 33;down<41;down++){
  XIo_Out8(VGA_START +  (W*down)+across,255);
    }
  }
  //draw grid line for 639, as 640 does not exist
    for(down = 33;down<41;down++){
  XIo_Out8(VGA_START +  (W*down)+639,255);
    }
    //draw extra 0 dash because pixels 319 and 320 are 0
    for(down = 33;down<41;down++){
  XIo_Out8(VGA_START +  (W*down)+319,255);
    }
    //draw axis
    for(axis=0;axis<640;axis++){
      XIo_Out8(VGA_START + (W*41)+axis,255);
    }

    //bottom grid
  for(across = 0;across<640;across += 64)
{
    for(down = 439;down<447;down++){
  XIo_Out8(VGA_START +  (W*down)+across,255);
    }
  }
    for(down = 439;down<447;down++){
  XIo_Out8(VGA_START +  (W*down)+639,255);
    }
    for(down = 33;down<41;down++){
  XIo_Out8(VGA_START +  (W*down)+319,255);
    }
    for(axis=0;axis<640;axis++){
      XIo_Out8(VGA_START + (W*438)+axis,255);
    }

//print labels
outstring("Passive Sonar",0,33);

outstring("2.5",2,0);
outstring("2.5",2,77);
outstring("2.5",57,0);
outstring("2.5",57,77);
outstring("2.0",2,7);
outstring("2.0",2,70);
outstring("2.0",57,7);
outstring("2.0",57,70);
outstring("1.5",2,15);
outstring("1.5",2,62);
outstring("1.5",57,15);
outstring("1.5",57,62);
outstring("1.0",2,23);
outstring("1.0",2,54);
outstring("1.0",57,23);
outstring("1.0",57,54);
outstring("0.5",2,31);
outstring("0.5",2,46);
outstring("0.5",57,31);
outstring("0.5",57,46);
outstring("0",2,40);
outstring("0",57,40);

outstring("Distance from center (meters)",59,25);

}

void outchar(char c,int row,int col)
{
  for (j=0;j<8;j++)
    {
      for (i=7;i>0;i--)
	{
	   XIo_Out8(VGA_START +  (W*((row*8)+j)) + (col*8)+(7-i),
	   ((alphabet[c-32][j]>>i)&1)*255); //extract bit from row
	}
}
}
   
